
#include "xfbrows.h"
#include "bitmaps.h"

void BTCreate (bp, win, x, y, w, h, str, fg, bg)
BUTT *bp;
Window win;
int x, y, w, h;
char *str;
unsigned long fg, bg;
{
	bp->win = win;
	bp->x = x;
	bp->y = y;
	bp->w = w;
	bp->h = h;
	bp->str = str;
	bp->fg = fg;
	bp->bg = bg;
	bp->lit = 0;
	bp->active = 1;
	bp->toggle = 0;
}

void BTSetActive (bp, act)
BUTT *bp;
int act;
{
	if (bp->active != act)
	{
		bp->active = act;
		BTRedraw (bp);
	}
}

void BTRedraw (bp)
BUTT *bp;
{
	int x, y, w, h, r;
	XPoint poly [9];

	x = bp->x;
	y=bp->y;
	w=bp->w;
	h=bp->h;
	r=3;

	poly [0].x = x;
	poly [0].y = y+r;
	poly [1].x = x;
	poly [1].y = y+h-r;
	poly [2].x = x+r;
	poly [2].y = y+h;
	poly [3].x = x+w-r;
	poly [3].y = y+h;
	poly [4].x = x+w;
	poly [4].y = y+h-r;
	poly [5].x = x+w;
	poly [5].y = y+r;
	poly [6].x = x+w-r;
	poly [6].y = y;
	poly [7].x = x+r;
	poly [7].y = y;
	poly [8].x = x;
	poly [8].y = y+r;

	if (!bp->active) bp->lit = 0;

	if (bp->lit) XSetForeground (theDisp, theGC, bp->fg);
	else XSetForeground (theDisp, theGC, bp->bg);
	XFillPolygon (theDisp, bp->win, theGC, poly, 9, Convex, CoordModeOrigin);

	XSetForeground (theDisp, theGC, bp->fg);
	XDrawLines (theDisp, bp->win, theGC, poly, 9, CoordModeOrigin);

	if (!bp->active)
	{
		XSetFillStyle (theDisp, theGC, FillStippled);
		XSetStipple (theDisp, theGC, grayStip);
	}

	if (bp->lit) XSetForeground (theDisp, theGC, bp->bg);
	else XSetForeground (theDisp, theGC, bp->fg);
	XDrawString (theDisp, bp->win, theGC, CENTERX (cfinfo, x+w/2, bp->str), 
		CENTERY (cfinfo, y+h/2), bp->str, strlen (bp->str));

	if (!bp->active) XSetFillStyle (theDisp, theGC, FillSolid);
}

int BTTrack (bp)
BUTT *bp;
{
	Window rW, cW;
	int x, y, rx, ry, rval, inval;
	unsigned int mask;

	if (!bp->active) return 0;

	bp->lit = !bp->lit;
	inval = bp->lit;

	BTRedraw (bp);
	XFlush (theDisp);
	Timer (75);

	while (XQueryPointer (theDisp, bp->win, &rW, &cW, &rx, &ry, &x, &y, &mask))
	{
		if (! (mask & Button1Mask)) break;
		if (bp->lit!=inval && PTINRECT (x, y, bp->x, bp->y, bp->w, bp->h))
			bp->lit = inval;BTRedraw (bp);XFlush (theDisp);
		if (bp->lit==inval && !PTINRECT (x, y, bp->x, bp->y, bp->w, bp->h))
			bp->lit = !inval;BTRedraw (bp);XFlush (theDisp);
	}

	rval = (bp->lit == inval);
	if (bp->lit && !bp->toggle) 
	{
		bp->lit = 0;
		BTRedraw (bp);
		XFlush (theDisp);
	}
	return (rval);
}

