
#include "xfbrows.h"

int disWIDE, disHIGH;
#define diaWIDE 470
#define diaHIGH 105

#define drawstr1 "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
#define drawstr2 "abcdefghijklmnopqrstuvwxyz"
#define drawstr3 "1234567890[]\\;',./{}|:\"<>?"

static char title [40];
static char *diacom, *dianame;
static char diainfo[50];

int SimpleEventLoop ();

char *ShortCutName (name, width)
char *name;
int width;
{
	char buf [MAXPATHLEN];
	char nam [MAXPATHLEN];

	if (StringWidth (name) > width)
	{
		strcpy (buf, name);
		while (StringWidth (buf) > width) buf [strlen(buf)-3]= '\0';
		strcpy (nam, buf);
		strcat (nam, "...");
	}
	else strcpy (nam, name);
	return (nam);
}

char *maketitle (t)
char *t;
{
	strcpy (title, PROGNAME);
	strcat (title, " ");
	strcat (title, t);
	title [0]= toupper (title [0]);
}

void CreateDisW ()
{
	int i, l;

	maketitle ("Font");
	XSetForeground (theDisp, theGC, infofg);
	XSetBackground (theDisp, theGC, infobg);
	SetFonts ();
	sprintf (diainfo, "Ascent: %d   Decent: %d",
		ASCENT, DESCENT);
	disWIDE = StringWidth (drawstr1)+30;
	if ((i = StringWidth (drawstr2)+30) > disWIDE) disWIDE = i;
	if ((i = StringWidth (drawstr3)+30) > disWIDE) disWIDE = i;
	SetNormal ();
	l = StringWidth (diainfo) + 110;
	if (l > disWIDE) disWIDE = l;
	if (disWIDE > 570) disWIDE = 570;
	if (disWIDE < 200) disWIDE = 200;
	disHIGH = 80+3*LINEHIGH;
	if (disHIGH > 270) disHIGH = 270;
	disW = XCreateSimpleWindow (theDisp, dirW, (DIRWIDE-disWIDE)/2,
		(DIRHIGH-disHIGH)/2, disWIDE-4, disHIGH-4, 
		bwidth, infofg, infobg);
	if (!disW) FatalError ("can't create dispaly window");
	XSelectInput (theDisp, disW, ExposureMask | ButtonPressMask);
	BTCreate (&sbut [S_SOK], disW, disWIDE-80, disHIGH-34, BUTTW, BUTTH, 
		"Ok", infofg, infobg);
	XMapRaised (theDisp, disW);
}

void RedrawDisW ()
{
	char str1[50];
	char str2[50];
	char str3[50];

	XSetForeground (theDisp, theGC, infofg);
	XSetBackground (theDisp, theGC, infobg);
	SetBold ();
	XDrawString (theDisp, disW, theGC, (disWIDE-StringWidth (title))/2, 
		15, title, strlen (title));
	SetNormal ();
	XDrawLine (theDisp, disW, theGC, 0, 20, disWIDE, 20);
	SetBold ();
	BTRedraw (&sbut [S_SOK]);
	SetNormal ();
	SetFonts ();
	strcpy (str1, drawstr1);
	strcpy (str2, drawstr2);
	strcpy (str3, drawstr3);
	if (dispWIDE = 570)
	{
		strcpy (str1, ShortCutName (drawstr1, 520));
		strcpy (str2, ShortCutName (drawstr2, 520));
		strcpy (str3, ShortCutName (drawstr3, 520));
	}
	XDrawString (theDisp, disW, theGC, 10, 30+LINEHIGH,
		str1, strlen (str1));
	if (disHIGH-70-LINEHIGH>LINEHIGH)
		XDrawString (theDisp, disW, theGC, 10, 30+2*LINEHIGH,
			str2, strlen (str2));
	if (disHIGH-70-2*LINEHIGH>LINEHIGH)
		XDrawString (theDisp, disW, theGC, 10, 30+3*LINEHIGH,
			str3, strlen (str3));
	SetNormal ();
	XDrawString (theDisp, disW, theGC, 10, disHIGH-20,
		diainfo, strlen (diainfo));
	XFlush (theDisp);
}

int DisplayEventLoop ()
{
	return (SimpleEventLoop (disW));
}

void CreateDiaW (comment, name)
char *comment, *name;
{
	diacom = comment;
	dianame = ShortCutName (name, diaWIDE-30);

	XSetForeground (theDisp, theGC, infofg);
	XSetBackground (theDisp, theGC, infobg);
	diaW = XCreateSimpleWindow (theDisp, dirW, (DIRWIDE-diaWIDE)/2,
		(DIRHIGH-diaHIGH)/2, diaWIDE-8, diaHIGH-8, 
		bwidth + 2, infofg, infobg);
	if (!diaW) FatalError ("can't create dialog window");
	XSelectInput (theDisp, diaW, ExposureMask | ButtonPressMask);
	BTCreate (&sbut [S_SOK], diaW, diaWIDE-80, diaHIGH-35, BUTTW, BUTTH, 
		"Ok", infofg, infobg);
	XMapRaised (theDisp, diaW);
}

void RedrawDiaW ()
{
	XSetForeground (theDisp, theGC, infofg);
	XSetBackground (theDisp, theGC, infobg);
	SetBold ();
	XDrawString (theDisp, diaW, theGC, (diaWIDE-StringWidth (title))/2, 
		15, title, strlen (title));
	SetNormal ();
	XDrawLine (theDisp, diaW, theGC, 0, 20, diaWIDE, 20);
	XDrawString (theDisp, diaW, theGC, 10, 40, diacom, strlen (diacom));
	XDrawString (theDisp, diaW, theGC, 10, 60, dianame, strlen (dianame));
	SetBold ();
	BTRedraw (&sbut [S_SOK]);
	SetNormal ();
}

void CreateErrW (comment, name)
char *comment, *name;
{
	maketitle ("Error");
	CreateDiaW (comment, name);
}

void RedrawErrW ()
{
	RedrawDiaW ();
	XBell (theDisp, 0);
}

int ErrorEventLoop ()
{
	return (SimpleEventLoop (diaW));
}

int SimpleEventLoop (win)
Window win;
{
	XEvent event;
	BUTT *bp;
	int end = 1;
	int ret = 0;

	XSetForeground (theDisp, theGC, infofg);
	XSetBackground (theDisp, theGC, infobg);
	bp = &sbut [S_SOK];

	XDefineCursor (theDisp, dirW, hand);
	XDefineCursor (theDisp, win, hand);
	while (end)
	{
		XNextEvent (theDisp, &event);
		switch (event.type)
		{
			case Expose:
				{
					XExposeEvent *exp_event = (XExposeEvent *) &event;

					ExposureWin (exp_event);
					if (exp_event->window == disW) RedrawDisW ();
					else if (exp_event->window == diaW) RedrawDiaW ();
				}
				break;
			case ButtonPress:
				{
				XButtonEvent *b = (XButtonEvent *) &event;
				switch (b->button)
				{
					case Button1: 
						if (PTINRECT (b->x, b->y, bp->x, bp->y, bp->w, bp->h))
							if (BTTrack (bp)) end = 0;
						break;
					default:
						break;
				}
				}
				break;
			default :
				break;
		}
	}
	XDefineCursor (theDisp, dirW, arrow);
	XDestroyWindow (theDisp, win);
	return (ret);
}

