
#include "xfbrows.h"
#include "bitmaps.h"

#define MAXNAMES	10000

#define LISTW 565
#define DDWIDE LISTW-80+15
#define MAXDEEP 30
#define MAXFNLEN 40
#define DEFFILENAME ""

static int listh;
static int numdirnames = 0;
static int toomuchfonts = 0;
static char filename [MAXPATHLEN];
static char typename [MAXPATHLEN];

static void RedrawDList ();
static int dnamcmp ();

void CreateDirW (geom)
char *geom;
{
	char message[50];

	listh = LINEHIGH * NLINES;

	dirW = CreateWindow (PROGNAME, geom, DIRWIDE, DIRHIGH, infofg, infobg);
	if (!dirW) FatalError ("couldn't create window!");

	dnamW = XCreateSimpleWindow (theDisp, dirW, 10, listh+46-ASCENT, 
		510, LINEHIGH+4, 1, infofg, infobg);
	if (!dnamW) FatalError ("can't create window");
	XSelectInput (theDisp, dnamW, ExposureMask);

	grayStip = XCreatePixmapFromBitmapData (theDisp, dirW, gray50_bits, 
		gray50_width, gray50_height, 1, 0, 1);

	LSCreate (&dList, dirW, 10, LINEHIGH-5, LISTW, listh, NLINES, 
		dirnames, numdirnames, 
		infofg, infobg, RedrawDList, 1, 0);

	BTCreate (&dbut [S_BQUIT], dirW, 530, listh+47-ASCENT, BUTTW, BUTTH, 
		"Quit", infofg, infobg);

	SetTypeName (DEFFILENAME);
	LoadCurrentDirectory ();
	XMapSubwindows (theDisp, dirW);
	XSelectInput (theDisp, dirW, ExposureMask | ButtonPressMask | KeyPressMask);
	XMapRaised (theDisp, dirW);
	XDefineCursor (theDisp, dirW, arrow);
	if (toomuchfonts)
	{
		sprintf (message, "There are more than %d fonts !!!", MAXNAMES);
		CreateErrW (message, "Reconfigure and recompile !!!");
		RedrawErrW ();
		ErrorEventLoop ();
	}
}
 
void RedrawDirW (x, y, w, h)
int x, y, w, h;
{
	int ypos;
	char foo [30];
	XRectangle xr;

	xr.x = x;
	xr.y = y;
	xr.width = w;
	xr.height = h;
	XSetClipRectangles (theDisp, theGC, 0, 0, &xr, 1, Unsorted);

	ypos = 4 + ASCENT;
	XSetForeground (theDisp, theGC, infobg);
	XFillRectangle (theDisp, dirW, theGC, 10, ypos-ASCENT, DIRWIDE, CHIGH);
	XSetForeground (theDisp, theGC, infofg);

	if (dList.nstr==1) strcpy (foo, "1 font");
	else sprintf (foo, "%d fonts", dList.nstr);

	ypos = dList.y + dList.h + 5 + ASCENT;
	XSetForeground (theDisp, theGC, infobg);
	XFillRectangle (theDisp, dirW, theGC, 10, ypos-ASCENT, DIRWIDE, CHIGH);
	XSetForeground (theDisp, theGC, infofg);
	SetBold ();
	XDrawString (theDisp, dirW, theGC, 10, ypos, foo, strlen (foo));
	SetNormal ();

	SetBold ();
	BTRedraw (&dbut [S_BQUIT]);
	SetNormal ();

	XSetClipMask (theDisp, theGC, None);
}

int ClickDirW (x, y)
int x, y;
{
	BUTT *bp;
	int bnum;

	for (bnum=0;bnum<S_NBUTTS;bnum++)
	{
		bp = &dbut [bnum];
		if (PTINRECT (x, y, bp->x, bp->y, bp->w, bp->h)) break;
	}
	if (bnum<S_NBUTTS) if (BTTrack (bp)) return (bnum);
	return -1;
}

void SelectDir (n)
int n;
{
	SetDirFName (dList.str [n]);
	if ((disfinfo = XLoadQueryFont (theDisp, filename)) == NULL)
	{
		CreateErrW ("Unable to load font:", filename);
		RedrawErrW ();
		ErrorEventLoop ();
		return;
	}
	CreateDisW ();
	RedrawDisW ();
	DisplayEventLoop ();
}

static void RedrawDList ()
{
	LSRedraw (&dList);
}

void SetFonts ()
{
	disfont = disfinfo->fid;
	XSetForeground (theDisp, theGC, infofg);
	XSetBackground (theDisp, theGC, infobg);
	XSetFont (theDisp, theGC, disfont);
	cfinfo = disfinfo;
}

void LoadCurrentDirectory ()
{
	int i;

	dirnames = XListFonts (theDisp, "*", MAXNAMES, &numdirnames);
	if (numdirnames == MAXNAMES) toomuchfonts = 1;
	qsort ((char *) dirnames, numdirnames, sizeof (char *), dnamcmp);
	LSNewData (&dList, dirnames, numdirnames);
	RedrawDirW (0, 0, DIRWIDE, DIRHIGH);
	SetDirFName (DEFFILENAME);
}

static int dnamcmp (s1, s2)
char **s1, **s2;
{
	return (strcmp ((*s1), (*s2)));
}

int DirKey (c)
int c;
{
	int len;

	len = strlen (typename);
 
	if (c>' ' && c<'\177')
	{
		if (c=='/') return (-1);
		if (len >= MAXFNLEN-1) return (-1);
		typename [len]=c;
		typename [len+1]='\0';
	}
	else if (c=='\010' || c=='\177')
	{
		if (len==0) return (-1);
		typename [len-1]='\0';
	}
	else if (c=='\025') strcpy (typename, "");
	else if (c==13)
	{
		if (strlen (typename) == 0) return (-1);
		strcpy (filename, typename);
		if ((disfinfo = XLoadQueryFont (theDisp, filename)) == NULL)
		{
			CreateErrW ("Unable to load font:", filename);
			RedrawErrW ();
			ErrorEventLoop ();
			return (0);
		}
		CreateDisW ();
		RedrawDisW ();
		DisplayEventLoop ();
		strcpy (typename, "");
	}
	else return (-1);

	SetTypeName (typename);
	return (0);
}

void RedrawDNamW ()
{
	int width, len;

	len = strlen (typename);
	XSetForeground (theDisp, theGC, infofg);
	XDrawString (theDisp, dnamW, theGC, 3, ASCENT+3, typename, len);
	width = StringWidth (typename);
	XDrawLine (theDisp, dnamW, theGC, 3+width+1, 3, 3+width+1, 3+CHIGH);
}

void SetDirFName (st)
char *st;
{
	strcpy (filename, st);
}

void SetTypeName (st)
char *st;
{
	strcpy (typename, st);
	XClearWindow (theDisp, dnamW);
	RedrawDNamW ();
}

