
#define NEEDSTIME
#include "xfbrows.h"

static int timerdone;

Window CreateWindow (name, geom, w, h, fg, bg)
char *name, *geom;
unsigned int w, h;
unsigned long fg, bg;
{
	Window win;
	XSetWindowAttributes xswa;
	unsigned int xswamask;
	XWMHints xwmh;
	XSizeHints hints;
	int i, x, y;
	int a, b;

	x = y = 1;
	i = XParseGeometry (geom, &x, &y, &a, &b);
	if (i&XValue || i&YValue) hints.flags = USPosition;
	else hints.flags = PPosition;

	hints.flags |= USSize;

	if (i&XValue && i&XNegative) x = dispWIDE - w - abs (x);
	if (i&YValue && i&YNegative) y = dispHIGH - h - abs (y);

	hints.x = x;
	hints.y = y;
	hints.width = w;
	hints.height = h;
	hints.min_width = w;
	hints.min_height = h;
	hints.max_width = w;
	hints.max_height = h;
	hints.flags |= PMaxSize | PMinSize;

	xswa.background_pixel = bg;
	xswa.border_pixel = fg;
	xswamask = CWBackPixel | CWBorderPixel;

	win = XCreateWindow (theDisp, rootW, x, y, w, h, 
		bwidth, CopyFromParent, CopyFromParent, 
		CopyFromParent, xswamask, &xswa);
	if (!win) return (win);

	XSetStandardProperties (theDisp, win, name, name, None, NULL, 0, &hints);

	xwmh.input = True;
	xwmh.flags = InputHint;
	if (icongeom)
	{
		i = XParseGeometry (icongeom, &x, &y, &a, &b);
		if ((i&XValue && i&XNegative) ||
			(i&YValue && i&YNegative))
				FatalError ("can't parse negativ icon position");
		if (i&XValue) xwmh.icon_x = x;
		if (i&YValue) xwmh.icon_y = y;
		xwmh.flags |= IconPositionHint;
	}
	if (iconic)
	{
		xwmh.flags |= StateHint;
		xwmh.initial_state = IconicState;
	}

	XSetWMHints (theDisp, win, &xwmh);

	return (win);
}

void SetBold ()
{
	XSetFont (theDisp, theGC, bfont);
	cfinfo = bfinfo;
}

void SetNormal ()
{
	XSetFont (theDisp, theGC, mfont);
	cfinfo = mfinfo;
}

int StringWidth (str)
char *str;
{
	return (XTextWidth (cfinfo, str, strlen (str)));
}
 
void ExposureWin (exp_event)
XExposeEvent *exp_event;
{
	if (exp_event->count>0 && exp_event->window != dirW) return;
	else if (exp_event->window == dirW) 
		RedrawDirW (exp_event->x, exp_event->y,
			exp_event->width, exp_event->height);
	else if (exp_event->window == dList.win) LSRedraw (&dList);
	else if (exp_event->window == dList.scrl.win) SCRedraw (&dList.scrl);
	else if (exp_event->window == dnamW) RedrawDNamW ();
}

void FatalError (identifier)
char *identifier;
{
	fprintf (stderr, "%s: %s\n", cmd, identifier);
	Quit (-1);
}

static void FreeMostResources ()
{
	if (!theDisp) return;
	if (dirW) XDestroyWindow (theDisp, dirW);
	XFreeFontNames (dirnames);
	XFlush (theDisp);
}

void Quit (i)
int i;
{ 
	FreeMostResources ();
	exit (i);
}

static void onalarm ()
{
	timerdone=1;
}

void Timer (n)
int n;
{
	long usec;
	struct itimerval it;

	if (!n) return;

#ifdef SCO
	if (!n) return;
	nap (n);
	return;
#else

#ifdef USLEEP
	usleep (n);
	return;
#else

#ifdef NOTIMER
	return;
#else

	usec = (long) n * 1000;
 
	memset (&it, 0, sizeof (it));
	if (usec>=1000000L)
	{
		it.it_value.tv_sec = usec / 1000000L;
		usec %= 1000000L;
	}

	it.it_value.tv_usec = usec;
	timerdone=0;
	signal (SIGALRM, onalarm);
	setitimer (ITIMER_REAL, &it, (struct itimerval *)0);
	while (1)
	{
		HOLD_SIG;
		if (timerdone) break;
		else PAUSE_SIG;
	}
	RELEASE_SIG;
	signal (SIGALRM, SIG_DFL);
#endif
#endif
#endif
}

