
#define REVDATE		"Rev: 01/07/91"

#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <string.h>
extern int   errno;
extern char *sys_errlist[];

/* neither IBM AOS 4.3, Convex, nor BSD 4.3 on VAX have <malloc.h> */
#if !defined(ibm032) && !defined(__convexc__) && \
    !(defined(vax) && !defined(ultrix))
#if defined(hp300) || defined(hp800)
#include <sys/malloc.h>
#else
#include <malloc.h>
#endif
#endif

#include <X11/Xos.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/keysym.h>

#if defined(NEEDSTIME) || defined(NEEDSDIR)
#include <sys/types.h>
#endif

#ifdef NEEDSTIME
#include <sys/time.h>
#include <signal.h>
#if defined(SCO) && !defined(NOTIMER)
#include <sys/itimer.h>
#endif
#ifndef  sigmask
#define  sigmask(m)      (1 << ((m)-1))
#endif
#endif

#ifdef SVR4
#define HOLD_SIG         sighold(SIGALRM)
#define RELEASE_SIG      sigrelse(SIGALRM)
#define PAUSE_SIG        sigpause(SIGALRM)
#else
#define HOLD_SIG         sigblock(sigmask(SIGALRM))
#define RELEASE_SIG      sigblock(0)
#define PAUSE_SIG        sigpause(0)
#endif

#ifdef i386
#undef  HOLD_SIG
#define HOLD_SIG
#undef  RELEASE_SIG
#define RELEASE_SIG
#undef  PAUSE_SIG
#define PAUSE_SIG
#endif

#ifndef MAXPATHLEN
#define MAXPATHLEN    512
#endif

#define PROGNAME	"xfbrows"
#define DEFDIRGEOM	"-10-10"

#define DIRWIDE		600
#define DIRHIGH		270

#define S_NBUTTS	2
#define S_BOPTI		0
#define S_BQUIT		1

#define S_SBUTTS	2
#define S_SOK		0
#define S_SCANCEL	1

#define C_FIFO		'f'
#define C_CHR		'c'
#define C_DIR		'd'
#define C_BLK		'b'
#define C_LNK		'l'
#define C_SOCK		's'
#define C_REG		' '

#define NLINES 12
#define BUTTW 60
#define BUTTH 19

#define SPACING 3
#define ASCENT   (cfinfo->ascent)
#define DESCENT  (cfinfo->descent)
#define CHIGH    (ASCENT + DESCENT)
#define LINEHIGH (CHIGH + SPACING)

#define STDINSTR "<stdin>"

#ifndef MAIN
#define WHERE extern
#else
#define WHERE
#endif

typedef struct
{
	Window win;
	int len;
	int vert;
	int active;
	int min, max;
	int val;
	int page;
	int tpos;
	int tmin, tmax;
	int tsize;
	unsigned long fg, bg;
	void (*drawobj)();
	int uplit, dnlit;
} SCRL;

typedef struct
{
	Window win;
	int x, y, w, h;
	int lit;
	int active;
	int toggle;
	unsigned long fg, bg;
	char *str;
} BUTT;

typedef struct
{
	Window win;
	int x, y, w, h;
	unsigned long fg, bg;
	char **str;
	int nstr;
	int selected;
	int nlines;
	SCRL scrl;
	int filetypes;
	int dirsonly;
} LIST;

#define CENTERX(f,x,str) ((x)-XTextWidth(f,str,strlen(str))/2)
#define CENTERY(f,y) ((y)-((f->ascent+f->descent)/2)+f->ascent)
#define RANGE(a,b,c) { if (a<b) a=b;  if (a>c) a=c; }
#define PTINRECT(x,y,rx,ry,rw,rh) \
           ((x)>=(rx) && (y)>=(ry) && (x)<=(rx)+(rw) && (y)<=(ry)+(rh))

WHERE Display		*theDisp;
WHERE int			theScreen;
WHERE unsigned int	ncells, dispWIDE, dispHIGH, dispDEEP;
WHERE Colormap		theCmap;
WHERE Window		rootW;
WHERE GC			theGC;
WHERE unsigned long	black, white, fg, bg, infofg, infobg;
WHERE Font			mfont, bfont, disfont;
WHERE XFontStruct	*mfinfo, *bfinfo, *cfinfo, *disfinfo;
WHERE Visual		*theVisual;
WHERE Cursor		arrow, target, hand;

WHERE char			*cmd;
WHERE int			mono;

WHERE int			ncols;
WHERE int			bwidth;

WHERE int			numnames, curname;
WHERE Pixmap		grayTile, grayStip;

WHERE Window		dirW, dnamW;
WHERE LIST			dList;
WHERE BUTT			dbut[S_NBUTTS], sbut[S_SBUTTS];
WHERE char			**dirnames;

WHERE Window		diaW, disW;

WHERE int			iconic;
WHERE char			*icongeom;

#undef WHERE

Window CreateWindow();
int StringWidth();
void SetBold (), SetNormal (), ExposureWin (), Timer(), FatalError(), Quit();

void LSCreate(), LSRedraw(), LSNewData();
int  LSClick();

void CreateDirW(), RedrawDirW(), LoadCurrentDirectory();
int ClickDirW(), DirKey();
void DoDisplay ();
void RedrawDDirW(), RedrawDNamW(), SelectDir(), TrackDDirW();
void SetDirFName(), SetTypeName();

void SCCreate(), SCSetRange(), SCSetVal(), SCRedraw(), SCTrack();

void BTCreate(), BTSetActive(), BTRedraw(); int  BTTrack();

void CreateDisW (), RedrawDisW (); int DisplayEventLoop ();
void CreateErrW (), RedrawErrW (); int ErrorEventLoop ();

void SetFonts ();

